﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;
using System.IO;

namespace BankSystem
{
    public class BankAccountEventArgs : EventArgs
    {
        private double transactionAmount;
        private DateTime timestamp;

        public BankAccountEventArgs(double transactionAmount)
        {
            this.transactionAmount = transactionAmount;
            timestamp = DateTime.Now;
        }

        public override string ToString()
        {
            return string.Format("Transaction amount {0}, timestamp {1}", transactionAmount, timestamp);
        }
    }

    public class BankAccount
    {
        // Fields.
        private string accountHolder;
        private double balance;
        private List<double> transactions = new List<double>();

        // Events.
        public event EventHandler<BankAccountEventArgs> ProtectionLimitExceeded;
        public event EventHandler<BankAccountEventArgs> Overdrawn;

        // Simple constructor.
        public BankAccount(string accountHolder)
        {
            this.accountHolder = accountHolder;
            this.balance = 0;
        }

        // Other methods.
        public void Deposit(double amount)
        {

        }

        public void Withdraw(double amount)
        {

        }

        public override string ToString()
        {
            return string.Format("Account {0}, balance {1}", accountHolder, balance);
        }
    }
}
